package com.lipaluma.test.db;

import java.util.LinkedHashSet;
import java.util.Set;

import org.springframework.test.context.TestContextManager;
import org.springframework.test.context.TestExecutionListener;

public class DBTestContextManager extends TestContextManager {
	public DBTestContextManager(Class<?> testClass) {
		super(testClass);
	}
	
	public DBTestContextManager(Class<?> testClass, String defaultContextLoaderClassName) {
		super(testClass, defaultContextLoaderClassName);
	}

	
	@Override
	protected Set<Class<? extends TestExecutionListener>> getDefaultTestExecutionListenerClasses() {
		Set<Class<? extends TestExecutionListener>> defaultListenerClasses = new LinkedHashSet<Class<? extends TestExecutionListener>>();
		defaultListenerClasses.add(org.springframework.test.context.support.DependencyInjectionTestExecutionListener.class);
		defaultListenerClasses.add(org.springframework.test.context.support.DirtiesContextTestExecutionListener.class);
		defaultListenerClasses.add(org.springframework.test.context.transaction.TransactionalTestExecutionListener.class);
		defaultListenerClasses.add(com.lipaluma.test.db.listeners.DBTestExecutionListener.class);
		return defaultListenerClasses;
	}
}
