package com.lipaluma.test.db.annotations.batch;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import com.lipaluma.test.db.internal.assertions.ColumnType;

/**
 * This annotation permits define a string key that will be replaced with
 * the value in {@link Batch} files or request to launch
 * @author Mario
 */
@Documented
@Inherited
@Retention(RetentionPolicy.RUNTIME)
public @interface Param {
	/**
	 * String key to replace
	 * @return
	 */
	String key();
	/**
	 * value to put
	 * @return
	 */
	String value();
	
//	/**
//	 * defines a list of params
//	 * @author Mario
//	 */
//	@Documented
//	@Inherited
//	@Target({ElementType.METHOD, ElementType.TYPE})
//	@Retention(RetentionPolicy.RUNTIME)
//	public @interface List {
//		Param[] value();
//	}
}
