package com.lipaluma.test.db.annotations.dataSource;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Overrides the dialect of a DataSource
 * @author Mario
 */
@Documented
@Inherited
@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
public @interface Dialect {
	/**
	 * Name of the DataSource if defined. <br/>
	 * If not defined, the dialect of the default DataSource will be overriden
	 * @return
	 */
	String dataSource() default "";
	com.lipaluma.test.db.internal.DialectEnum value();

	/**
	 * Overrides several Dialects for several DataSource
	 * @author Mario
	 *
	 */
	@Documented
	@Inherited
	@Target(ElementType.TYPE)
	@Retention(RetentionPolicy.RUNTIME)
	public @interface List {
		Dialect[] value();
	}}
