package com.lipaluma.test.db.exceptions;

/**
 * Error on the SQL request
 * @author Mario
 */
public class SQLRequestFailedException extends DBTestException {
	private static final long serialVersionUID = 1L;

	private String request;
	
	public SQLRequestFailedException(String request, String message, Throwable cause) {
		super(message, cause);
		this.request = request;
	}

	public SQLRequestFailedException(String request, Throwable cause) {
		super("Request failed on Assertion ["+request+"]", cause);
		this.request = request;
	}
	
	public String getRequest() {
		return request;
	}
}
