package com.lipaluma.test.db.internal.assertions;

import static org.junit.Assert.assertEquals;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Date;

import org.joda.time.format.DateTimeFormat;

/**
 * test a date column
 * @author Mario
 */
class DateColumn extends Column<Date> {

	private DateColumn(Builder builder) {
		super(builder);
	}
	
	@Override
	public void assertValue(ResultSet rs) throws SQLException {
		if(name == null)
			assertEquals(getErrorMessageOnIndexColumn(), expectedValue, rs.getDate(index));
		else
			assertEquals(getErrorMessageOnNamedColumn(), expectedValue, rs.getDate(name));
	}

	public static DateColumn.Builder builder(String request) {
		return new Builder(request);
	}

	public static class Builder extends Column.Builder<Date> {

		public Builder(String request) {
			super(request);
		}

		@Override
		public DateColumn.Builder withExpectedValue(String expected) {
			this.expectedValue = DateTimeFormat.forPattern("yyyy-MM-dd").parseDateTime(expected).toDate();
			return this;
		}

		@Override
		public DateColumn build() {
			return new DateColumn(this);
		}

	}
}
