package com.lipaluma.test.db.internal.assertions;

import static org.junit.Assert.assertEquals;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * test a long, integer, short column
 * @author Mario
 */
class LongColumn extends Column<Long> {

	private LongColumn(Builder builder) {
		super(builder);
	}
	
	@Override
	public void assertValue(ResultSet rs) throws SQLException {
		if(name == null)
			assertEquals(getErrorMessageOnIndexColumn(), expectedValue.longValue(), rs.getLong(index));
		else
			assertEquals(getErrorMessageOnNamedColumn(), expectedValue.longValue(), rs.getLong(name));
	}

	public static LongColumn.Builder builder(String request) {
		return new Builder(request);
	}

	public static class Builder extends Column.Builder<Long>  {

		public Builder(String request) {
			super(request);
		}

		@Override
		public LongColumn.Builder withExpectedValue(String expected) {
			this.expectedValue = Long.parseLong(expected);
			return this;
		}

		@Override
		public LongColumn build() {
			return new LongColumn(this);
		}

	}
}
