package com.lipaluma.test.db.internal.batch;

import java.util.ArrayList;
import java.util.List;

public class Param {
	private String key;
	private String value;
	
	public Param() {}
	public Param(String key, String value) {
		super();
		this.key = key;
		this.value = value;
	}
	
	public String getKey() {
		return key;
	}
	public void setKey(String key) {
		this.key = key;
	}
	public String getValue() {
		return value;
	}
	public void setValue(String value) {
		this.value = value;
	}
	
	public static Param[] convertAll(com.lipaluma.test.db.annotations.batch.Param[] annotatedParams) {
		List<Param> params = new ArrayList<Param>();
		for (com.lipaluma.test.db.annotations.batch.Param annotatedParam : annotatedParams) {
			params.add(convert(annotatedParam));
		}
		return params.toArray(new Param[params.size()]);
	}

	public static Param convert(com.lipaluma.test.db.annotations.batch.Param annotatedParam) {
		return new Param(annotatedParam.key(), annotatedParam.value());
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((key == null) ? 0 : key.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Param other = (Param) obj;
		if (key == null) {
			if (other.key != null)
				return false;
		} else if (!key.equals(other.key))
			return false;
		return true;
	}
	
}
